_firefoxpwa() {
    local i cur prev opts cmd
    COMPREPLY=()
    if [[ "${BASH_VERSINFO[0]}" -ge 4 ]]; then
        cur="$2"
    else
        cur="${COMP_WORDS[COMP_CWORD]}"
    fi
    prev="$3"
    cmd=""
    opts=""

    for i in "${COMP_WORDS[@]:0:COMP_CWORD}"
    do
        case "${cmd},${i}" in
            ",$1")
                cmd="firefoxpwa"
                ;;
            firefoxpwa,help)
                cmd="firefoxpwa__subcmd__help"
                ;;
            firefoxpwa,profile)
                cmd="firefoxpwa__subcmd__profile"
                ;;
            firefoxpwa,runtime)
                cmd="firefoxpwa__subcmd__runtime"
                ;;
            firefoxpwa,site)
                cmd="firefoxpwa__subcmd__site"
                ;;
            firefoxpwa__subcmd__help,help)
                cmd="firefoxpwa__subcmd__help__subcmd__help"
                ;;
            firefoxpwa__subcmd__help,profile)
                cmd="firefoxpwa__subcmd__help__subcmd__profile"
                ;;
            firefoxpwa__subcmd__help,runtime)
                cmd="firefoxpwa__subcmd__help__subcmd__runtime"
                ;;
            firefoxpwa__subcmd__help,site)
                cmd="firefoxpwa__subcmd__help__subcmd__site"
                ;;
            firefoxpwa__subcmd__help__subcmd__profile,create)
                cmd="firefoxpwa__subcmd__help__subcmd__profile__subcmd__create"
                ;;
            firefoxpwa__subcmd__help__subcmd__profile,list)
                cmd="firefoxpwa__subcmd__help__subcmd__profile__subcmd__list"
                ;;
            firefoxpwa__subcmd__help__subcmd__profile,remove)
                cmd="firefoxpwa__subcmd__help__subcmd__profile__subcmd__remove"
                ;;
            firefoxpwa__subcmd__help__subcmd__profile,update)
                cmd="firefoxpwa__subcmd__help__subcmd__profile__subcmd__update"
                ;;
            firefoxpwa__subcmd__help__subcmd__runtime,install)
                cmd="firefoxpwa__subcmd__help__subcmd__runtime__subcmd__install"
                ;;
            firefoxpwa__subcmd__help__subcmd__runtime,patch)
                cmd="firefoxpwa__subcmd__help__subcmd__runtime__subcmd__patch"
                ;;
            firefoxpwa__subcmd__help__subcmd__runtime,uninstall)
                cmd="firefoxpwa__subcmd__help__subcmd__runtime__subcmd__uninstall"
                ;;
            firefoxpwa__subcmd__help__subcmd__site,install)
                cmd="firefoxpwa__subcmd__help__subcmd__site__subcmd__install"
                ;;
            firefoxpwa__subcmd__help__subcmd__site,launch)
                cmd="firefoxpwa__subcmd__help__subcmd__site__subcmd__launch"
                ;;
            firefoxpwa__subcmd__help__subcmd__site,uninstall)
                cmd="firefoxpwa__subcmd__help__subcmd__site__subcmd__uninstall"
                ;;
            firefoxpwa__subcmd__help__subcmd__site,update)
                cmd="firefoxpwa__subcmd__help__subcmd__site__subcmd__update"
                ;;
            firefoxpwa__subcmd__profile,create)
                cmd="firefoxpwa__subcmd__profile__subcmd__create"
                ;;
            firefoxpwa__subcmd__profile,help)
                cmd="firefoxpwa__subcmd__profile__subcmd__help"
                ;;
            firefoxpwa__subcmd__profile,list)
                cmd="firefoxpwa__subcmd__profile__subcmd__list"
                ;;
            firefoxpwa__subcmd__profile,remove)
                cmd="firefoxpwa__subcmd__profile__subcmd__remove"
                ;;
            firefoxpwa__subcmd__profile,update)
                cmd="firefoxpwa__subcmd__profile__subcmd__update"
                ;;
            firefoxpwa__subcmd__profile__subcmd__help,create)
                cmd="firefoxpwa__subcmd__profile__subcmd__help__subcmd__create"
                ;;
            firefoxpwa__subcmd__profile__subcmd__help,help)
                cmd="firefoxpwa__subcmd__profile__subcmd__help__subcmd__help"
                ;;
            firefoxpwa__subcmd__profile__subcmd__help,list)
                cmd="firefoxpwa__subcmd__profile__subcmd__help__subcmd__list"
                ;;
            firefoxpwa__subcmd__profile__subcmd__help,remove)
                cmd="firefoxpwa__subcmd__profile__subcmd__help__subcmd__remove"
                ;;
            firefoxpwa__subcmd__profile__subcmd__help,update)
                cmd="firefoxpwa__subcmd__profile__subcmd__help__subcmd__update"
                ;;
            firefoxpwa__subcmd__runtime,help)
                cmd="firefoxpwa__subcmd__runtime__subcmd__help"
                ;;
            firefoxpwa__subcmd__runtime,install)
                cmd="firefoxpwa__subcmd__runtime__subcmd__install"
                ;;
            firefoxpwa__subcmd__runtime,patch)
                cmd="firefoxpwa__subcmd__runtime__subcmd__patch"
                ;;
            firefoxpwa__subcmd__runtime,uninstall)
                cmd="firefoxpwa__subcmd__runtime__subcmd__uninstall"
                ;;
            firefoxpwa__subcmd__runtime__subcmd__help,help)
                cmd="firefoxpwa__subcmd__runtime__subcmd__help__subcmd__help"
                ;;
            firefoxpwa__subcmd__runtime__subcmd__help,install)
                cmd="firefoxpwa__subcmd__runtime__subcmd__help__subcmd__install"
                ;;
            firefoxpwa__subcmd__runtime__subcmd__help,patch)
                cmd="firefoxpwa__subcmd__runtime__subcmd__help__subcmd__patch"
                ;;
            firefoxpwa__subcmd__runtime__subcmd__help,uninstall)
                cmd="firefoxpwa__subcmd__runtime__subcmd__help__subcmd__uninstall"
                ;;
            firefoxpwa__subcmd__site,help)
                cmd="firefoxpwa__subcmd__site__subcmd__help"
                ;;
            firefoxpwa__subcmd__site,install)
                cmd="firefoxpwa__subcmd__site__subcmd__install"
                ;;
            firefoxpwa__subcmd__site,launch)
                cmd="firefoxpwa__subcmd__site__subcmd__launch"
                ;;
            firefoxpwa__subcmd__site,uninstall)
                cmd="firefoxpwa__subcmd__site__subcmd__uninstall"
                ;;
            firefoxpwa__subcmd__site,update)
                cmd="firefoxpwa__subcmd__site__subcmd__update"
                ;;
            firefoxpwa__subcmd__site__subcmd__help,help)
                cmd="firefoxpwa__subcmd__site__subcmd__help__subcmd__help"
                ;;
            firefoxpwa__subcmd__site__subcmd__help,install)
                cmd="firefoxpwa__subcmd__site__subcmd__help__subcmd__install"
                ;;
            firefoxpwa__subcmd__site__subcmd__help,launch)
                cmd="firefoxpwa__subcmd__site__subcmd__help__subcmd__launch"
                ;;
            firefoxpwa__subcmd__site__subcmd__help,uninstall)
                cmd="firefoxpwa__subcmd__site__subcmd__help__subcmd__uninstall"
                ;;
            firefoxpwa__subcmd__site__subcmd__help,update)
                cmd="firefoxpwa__subcmd__site__subcmd__help__subcmd__update"
                ;;
            *)
                ;;
        esac
    done

    case "${cmd}" in
        firefoxpwa)
            opts="-h -V --help --version site profile runtime help"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 1 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__help)
            opts="site profile runtime help"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__help__subcmd__help)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__help__subcmd__profile)
            opts="list create remove update"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__help__subcmd__profile__subcmd__create)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 4 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__help__subcmd__profile__subcmd__list)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 4 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__help__subcmd__profile__subcmd__remove)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 4 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__help__subcmd__profile__subcmd__update)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 4 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__help__subcmd__runtime)
            opts="install uninstall patch"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__help__subcmd__runtime__subcmd__install)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 4 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__help__subcmd__runtime__subcmd__patch)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 4 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__help__subcmd__runtime__subcmd__uninstall)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 4 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__help__subcmd__site)
            opts="launch install uninstall update"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__help__subcmd__site__subcmd__install)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 4 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__help__subcmd__site__subcmd__launch)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 4 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__help__subcmd__site__subcmd__uninstall)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 4 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__help__subcmd__site__subcmd__update)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 4 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__profile)
            opts="-h -V --help --version list create remove update help"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__profile__subcmd__create)
            opts="-h -V --name --description --template --help --version"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --name)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --description)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --template)
                    COMPREPLY=()
                    if [[ "${BASH_VERSINFO[0]}" -ge 4 ]]; then
                        compopt -o plusdirs
                    fi
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__profile__subcmd__help)
            opts="list create remove update help"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__profile__subcmd__help__subcmd__create)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 4 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__profile__subcmd__help__subcmd__help)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 4 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__profile__subcmd__help__subcmd__list)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 4 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__profile__subcmd__help__subcmd__remove)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 4 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__profile__subcmd__help__subcmd__update)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 4 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__profile__subcmd__list)
            opts="-h -V --help --version"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__profile__subcmd__remove)
            opts="-q -h -V --quiet --help --version"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__profile__subcmd__update)
            opts="-h -V --name --description --template --help --version"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --name)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --description)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --template)
                    COMPREPLY=()
                    if [[ "${BASH_VERSINFO[0]}" -ge 4 ]]; then
                        compopt -o plusdirs
                    fi
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__runtime)
            opts="-h -V --help --version install uninstall patch help"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__runtime__subcmd__help)
            opts="install uninstall patch help"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__runtime__subcmd__help__subcmd__help)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 4 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__runtime__subcmd__help__subcmd__install)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 4 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__runtime__subcmd__help__subcmd__patch)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 4 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__runtime__subcmd__help__subcmd__uninstall)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 4 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__runtime__subcmd__install)
            opts="-h -V --link --help --version"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__runtime__subcmd__patch)
            opts="-h -V --help --version"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__runtime__subcmd__uninstall)
            opts="-h -V --help --version"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__site)
            opts="-h -V --help --version launch install uninstall update help"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__site__subcmd__help)
            opts="launch install uninstall update help"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__site__subcmd__help__subcmd__help)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 4 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__site__subcmd__help__subcmd__install)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 4 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__site__subcmd__help__subcmd__launch)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 4 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__site__subcmd__help__subcmd__uninstall)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 4 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__site__subcmd__help__subcmd__update)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 4 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__site__subcmd__install)
            opts="-h -V --document-url --profile --start-url --icon-url --name --description --categories --keywords --launch-on-login --launch-on-browser --launch-now --no-system-integration --user-agent --tls-root-certificates-der --tls-root-certificates-pem --tls-danger-accept-invalid-certs --tls-danger-accept-invalid-hostnames --help --version"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --document-url)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --profile)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --start-url)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --icon-url)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --name)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --description)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --categories)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --keywords)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --launch-on-login)
                    COMPREPLY=($(compgen -W "true false" -- "${cur}"))
                    return 0
                    ;;
                --launch-on-browser)
                    COMPREPLY=($(compgen -W "true false" -- "${cur}"))
                    return 0
                    ;;
                --user-agent)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --tls-root-certificates-der)
                    local oldifs
                    if [ -n "${IFS+x}" ]; then
                        oldifs="$IFS"
                    fi
                    IFS=$'\n'
                    COMPREPLY=($(compgen -f "${cur}"))
                    if [ -n "${oldifs+x}" ]; then
                        IFS="$oldifs"
                    fi
                    if [[ "${BASH_VERSINFO[0]}" -ge 4 ]]; then
                        compopt -o filenames
                    fi
                    return 0
                    ;;
                --tls-root-certificates-pem)
                    local oldifs
                    if [ -n "${IFS+x}" ]; then
                        oldifs="$IFS"
                    fi
                    IFS=$'\n'
                    COMPREPLY=($(compgen -f "${cur}"))
                    if [ -n "${oldifs+x}" ]; then
                        IFS="$oldifs"
                    fi
                    if [[ "${BASH_VERSINFO[0]}" -ge 4 ]]; then
                        compopt -o filenames
                    fi
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__site__subcmd__launch)
            opts="-h -V --url --protocol --help --version"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --url)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --protocol)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__site__subcmd__uninstall)
            opts="-q -h -V --quiet --no-system-integration --help --version"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        firefoxpwa__subcmd__site__subcmd__update)
            opts="-h -V --start-url --icon-url --name --description --categories --keywords --enabled-url-handlers --enabled-protocol-handlers --launch-on-login --launch-on-browser --no-manifest-updates --no-icon-updates --no-system-integration --user-agent --tls-root-certificates-der --tls-root-certificates-pem --tls-danger-accept-invalid-certs --tls-danger-accept-invalid-hostnames --help --version"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --start-url)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --icon-url)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --name)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --description)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --categories)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --keywords)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --enabled-url-handlers)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --enabled-protocol-handlers)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --launch-on-login)
                    COMPREPLY=($(compgen -W "true false" -- "${cur}"))
                    return 0
                    ;;
                --launch-on-browser)
                    COMPREPLY=($(compgen -W "true false" -- "${cur}"))
                    return 0
                    ;;
                --user-agent)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --tls-root-certificates-der)
                    local oldifs
                    if [ -n "${IFS+x}" ]; then
                        oldifs="$IFS"
                    fi
                    IFS=$'\n'
                    COMPREPLY=($(compgen -f "${cur}"))
                    if [ -n "${oldifs+x}" ]; then
                        IFS="$oldifs"
                    fi
                    if [[ "${BASH_VERSINFO[0]}" -ge 4 ]]; then
                        compopt -o filenames
                    fi
                    return 0
                    ;;
                --tls-root-certificates-pem)
                    local oldifs
                    if [ -n "${IFS+x}" ]; then
                        oldifs="$IFS"
                    fi
                    IFS=$'\n'
                    COMPREPLY=($(compgen -f "${cur}"))
                    if [ -n "${oldifs+x}" ]; then
                        IFS="$oldifs"
                    fi
                    if [[ "${BASH_VERSINFO[0]}" -ge 4 ]]; then
                        compopt -o filenames
                    fi
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
    esac
}

if [[ "${BASH_VERSINFO[0]}" -eq 4 && "${BASH_VERSINFO[1]}" -ge 4 || "${BASH_VERSINFO[0]}" -gt 4 ]]; then
    complete -F _firefoxpwa -o nosort -o bashdefault -o default firefoxpwa
else
    complete -F _firefoxpwa -o bashdefault -o default firefoxpwa
fi
